library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity moteur is

port( cw,a,l,clk : in std_logic;
		b: out std_logic_vector (3 downto 0));
end moteur;

architecture a of moteur is
type type_etat is (x0,x1,x2,x3,x4,x5,x6,x7,x8);
signal etat : type_etat;
begin
	process (clk)
	begin

	if(clk'event and clk='1') then
		if(l='1') then etat <= x8;
		elsif(a='1') then etat <= etat;
		-- Sens normal
		elsif(cw='1') then
			case etat is
				when x0 => etat <= x1;
				when x1 => etat <= x2;
				when x2 => etat <= x3;
				when x3 => etat <= x4;
				when x4 => etat <= x5;
				when x5 => etat <= x6;
				when x6 => etat <= x7;
				when x7 => etat <= x0;
				when x8 => etat <= x0;
			end case;
		-- Sens inverse
		else
			case etat is
				when x0 => etat <= x7;
				when x1 => etat <= x0;
				when x2 => etat <= x1;
				when x3 => etat <= x2;
				when x4 => etat <= x3;
				when x5 => etat <= x4;
				when x6 => etat <= x5;
				when x7 => etat <= x6;
				when x8 => etat <= x0;
			end case;
		end if;
	end if;
	end process;

	with etat select
		b <= "1000" when x0,
			 "1100" when x1,
			 "0100" when x2,
			 "0110" when x3,
			 "0010" when x4,
			 "0011" when x5,
			 "0001" when x6,
			 "1001" when x7,
			 "0000" when x8;
end a;
